From ada768758fa74c8f8ed6dd9f1ac0f9d9c8abff85 Mon Sep 17 00:00:00 2001
From: Paul Eggert <eggert@cs.ucla.edu>
Date: Thu, 19 May 2016 08:38:55 -0700
Subject: [PATCH] Allow null entries in face and image cache
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Problem reported by Tino Calancha (Bug#23580).
* src/dispextern.h (FACE_FROM_ID, IMAGE_FROM_ID):
Don’t assume that the result is non-null.
* src/xdisp.c (fill_image_glyph_string):
Restore check that image pointer is non-null.
---
 src/dispextern.h | 2 --
 src/xdisp.c      | 1 +
 2 files changed, 1 insertion(+), 2 deletions(-)

diff --git a/src/dispextern.h b/src/dispextern.h
index 4deebc1..e83b7c7 100644
--- a/src/dispextern.h
+++ b/src/dispextern.h
@@ -1815,7 +1815,6 @@ struct face_cache
 
 #define FACE_FROM_ID(F, ID)					\
   (eassert (UNSIGNED_CMP (ID, <, FRAME_FACE_CACHE (F)->used)),	\
-   eassume (FRAME_FACE_CACHE (F)->faces_by_id[ID]),		\
    FRAME_FACE_CACHE (F)->faces_by_id[ID])
 
 /* Return a pointer to the face with ID on frame F, or null if such a
@@ -3093,7 +3092,6 @@ struct image_cache
 
 #define IMAGE_FROM_ID(F, ID)					\
   (eassert (UNSIGNED_CMP (ID, <, FRAME_IMAGE_CACHE (F)->used)),	\
-   eassume (FRAME_IMAGE_CACHE (F)->images[ID]),			\
    FRAME_IMAGE_CACHE (F)->images[ID])
 
 /* Value is a pointer to the image with id ID on frame F, or null if
diff --git a/src/xdisp.c b/src/xdisp.c
index e18af2f..10a0cf2 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -24870,6 +24870,7 @@ fill_image_glyph_string (struct glyph_string *s)
 {
   eassert (s->first_glyph->type == IMAGE_GLYPH);
   s->img = IMAGE_FROM_ID (s->f, s->first_glyph->u.img_id);
+  eassert (s->img);
   s->slice = s->first_glyph->slice.img;
   s->face = FACE_FROM_ID (s->f, s->first_glyph->face_id);
   s->font = s->face->font;
-- 
2.5.5

